
<div class="container" >

    <h2>Configuration <a name="configuration"></a></h2>
    <pre type="shell">
        [mysqld]
        #数据库标识，每个数据库标识必须唯一
        server-id=1
        # 日志记录文件名（并不是完整的文件名，实际生成的日志文件名以该名作为前缀，注意符号“.”不能用)%
        log-bin=%
        #即当主数据库又当从数据库时需开启log-slave-updates项
        #log-slave-updates

        #让slave在执行同步时记录更多的错误日志默认启用了, skip-log-warnings 就可以禁用它
        log-warnings
        skip-log-warnings

        # 在master当机或者网络连接中断后，slave在重新连接到master之前休眠的秒数.如果在 `master.info` 文件中存在，就优先使用它。如果没有设置，默认是60
        master-connect-retry=seconds

        #master服务器的主机名或者ip地址。如果没有设置它，slave线程无法启动。如果存在的话，`master.info` 文件中选项值优先被读取
        master-host=host=

        #master上监听的TCP/IP端口号。如果存在的话，`master.info` 文件中选项值优先被读取。如果没有设置，就当作预编译的设置。如果没有修改 configure 选项参数，那么就是3306
        master-port=port_number
        
        #用于设定用SSL安全连接到master的选项。它们的意义对应于""中提到的 --ssl, --ssl-ca, --ssl-capath, --ssl-cert, --ssl-cipher, --ssl-key 选项。如果存在的话，`master.info` 文件中选项值优先被读取。这些选项是从MySQL 4.1.1之后开始可以用的。
        master-ssl,--master-ssl-ca=file_name,--master-ssl-capath=directory_name,
        master-ssl-cert=file_name,--master-ssl-cipher=cipher_list,--master-ssl-key=file_name

        #用于被授权连接到master上运行同步的帐户。这个帐户必须有 REPLICATION SLAVE 权限(在MySQL 4.0.2以前，则是 FILE 权限)。如果存在的话，`master.info` 文件中选项值优先被读取。如果没有设置，就当作是 test
        master-user=username


        #用于被授权连接到master上运行同步的帐户密码。如果存在的话，`master.info` 文件中选项值优先被读取。如果没有设置，就当作是空密码
        master-password=password

        #中继日志自动轮转(rotate)的大小。详情请看""。这个选项是从MySQL 4.0.14之后才可以用的
        max-relay-log-size=#

        #这个选项令slave除了slave线程或者拥有 SUPER 权限用户之外的都不能更新数据。这能确保slave不会接受来自其他客户端的更新。这个选项是从MySQL 4.0.14开始有的。
        read-only

        #中继日志的名字。默认名字是 host_name-relay-bin.nnn，host_name 是slave服务器的主机名，nnn 是指中继日志的顺序号。可以用这个选项创建不依赖主机名的中继日志，或者在中继日志越来越大(不想降低 max_relay_log_size 的值)且需要将它们放在非数据文件目录下，或者想使用磁盘间的负载均衡来提高速度等情况。
        relay-log=file_name

        #中继日志索引文件的位置及文件名。它的默认值是 host_name-relay-bin.index，host_name 是slave服务器主机名。
        relay-log-index=file_name

        #slave上记录中继日志信息的文件名。默认是数据文件目录下的`relay-log.info`。
        relay-log-info-file=file_name

        #在不需要中继日志时禁用或启用自动清除。默认值是1(启用)。这是一个全局变量，可以用 SET GLOBAL relay_log_purge 来动态更改。这个选项从MySQL 4.1.1开始可以用。
        --relay-log-purge={0|1}

        #用于加大slave上中继日志的总大小(如果值为0表示"无限")。这在slave主机只有有限的空间时很有用。当达到这个限制 后，I/O线程直到SQL线程删除一些无用的中继日志后才会继续从master读取二进制日志事件。注意，这个限制不是绝对的：在删除中继日志之 前，SQL线程可能还需要更多的二进制日志事件。这种情况下，I/O线程会超越这个限制，直到SQL线程删除一些中继日志，因为如果不这么做的话就会导致 死锁(在MySQL 4.0.13之前就是这样)。不要设置 --relay-log-space-limit 的值小于2倍 --max-relay-log-size (如果 --max-relay-log-size 的值为0，则是 --max-binlog-size ) 的值。在这种情况下，由于已经超过 --relay-log-space-limit 了，I/O线程需要等待更多的剩余空间，但是SQL线程没有可以删除的中继日志来满足I/O线程的需求。这就会强制I/O线程暂时忽略 --relay-log-space-limit 限制。
        relay-log-space-limit=#

        #告诉slave只同步那些缺省数据库是 db_name (也就是用 USE 选中的)的语句。想要指定更多的数据库，只需多次使用该选项，每次指定一个数据库。注意，类似 UPDATE some_db.some_table SET foo='bar' 这样的跨库操作语句以及没有选中数据库的操作都不会被同步。如果必须使用跨库操作，要确保使用MySQL 3.23.28或更高，并且使用 --replicate-wild-do-table=db_name.% 选项。请仔细阅读最后面的注意事项
        --replicate-do-db=db_name

        #slave记录master信息的文件名。默认名字是 `master.info`，放在数据文件目录下
        master-info-file=file_name

        #告诉slave只同步那些指定的数据表。想要指定更多的数据表，只需多次使用该选项，每次指定一个数据表。这个选项支持跨库更新，和 --replicate-do-db 选项相反。请仔细阅读最后面的注意事项。
        replicate-do-table=db_name.tbl_name

        #告诉slave不要同步那些缺省数据库是 db_name (也就是用 USE 选中的)的语句。想要指定更多的数据库，只需多次使用该选项，每次指定一个数据库。如果有跨库操作且希望这些操作要被同步就不要使用该选项。请仔细阅读最后面的注意事项。
        replicate-ignore-db=db_name

        #限制slave只同步那些匹配指定模式的数据表。模式中可以包含通配符 `%` 和 `_`，它们的含义和 LIKE 模式一样。想要指定更多的数据表，只需多次使用该选项，每次指定一个数据表。
        replicate-wild-do-table=db_name.tbl_name

        #该选项用于slave之上。通常使用它的默认值0，用于避免无限同步循环。如果设置为1，那么slave就不会忽略那些跟它有同样服务器编号的更新日志了；通常它只用于比较罕见的配置中
        replicate-same-server-id

        #告诉slave服务器在启动时不要运行slave线程。只需使用 START SLAVE 语句来启动slave线程。
        skip-slave-start

        #如果它设置为1，并且maste/slave都支持的话，就采用压缩协议传输数据。
        slave_compressed_protocol={0|1}

        #slave创建临时文件的目录。这个选项值默认地和系统变量 tmpdir 的值一样。slave的SQL线程同步 LOAD DATA INFILE 语句时，它从中继日志中提取出要被加载的文件放到临时文件中，然后把它们加载到slave中。如果在master上加载的文件很大，那么slave上的临时文件也会很大。因此建议在slave上指定这个选项时把它放在剩余空间比较多的文件系统上。这是，最好也指定 --relay-log 到那个文件系统中，因为中继日志可能也会很大。--slave-load-tmpdir 必须指向基于磁盘的文件系统，而不能是基于内存的文件系统：slave可能会在机器重启后同步 LOAD DATA INFILE 语句时需要用到这个临时文件。这个目录同样不能在会被操作系统的启动进程清除的目录下
        slave-load-tmpdir=file_name


        #salve放弃读之后等待多少秒再次从master读取更多的数据，考虑到了连接断开，尝试重连的情况。第一次重试会在超时后立刻执行。重试的时间间隔由选项 --master-connect-retry 控制
        slave-net-timeout=seconds

        #通常，发生错误时同步就会停止，以提供手工解决数据不一致的情况。这个选项告诉slave的SQL线程当执行语句时返回的错误代码在该列表中时继续运行
        slave-skip-errors= [err_code1,err_code2,... | all]


        #让slave在执行同步时记录更多的错误日志
        log-warnings
    </pre>
    <br> <br>

    <h2>Install <a name="install"></a></h2>
    <pre type="shell">
        #wget https://dev.mysql.com/get/mysql57-community-release-el7-9.noarch.rpm

        #rpm -ivh mysql80-community-release-el8-1.noarch.rpm
        #yum install openssl-libs.i686 -y

        #yum install epel-rpm-macros.noarch -y
        #yum upgrade -y && yum update -y        
    </pre>
    <br> <br>

    <h2>Change Password <a name="chgpwd"></a></h2>
    <pre type="shell">
        #create user 'root'@'localhost' identified by 'root@root.Pwd';
        # alter user root@localhost identified with mysql_native_password by 'root@root.Pwd';
    </pre>
    <br> <br>


    <h2>Synchronize(镜像配置 master->slave)  <a name="synchronize"></a></h2>
    <h3>master主数据库my.conf配置</h3>
    <pre type="shell">
        [mysqld]
        #数据库标识，每个数据库标识必须唯一
        server-id=1
        # 日志记录文件名（并不是完整的文件名，实际生成的日志文件名以该名作为前缀，注意符号“.”不能用)%
        log-bin=mysql-bin

        # 指定索引文件的位置
        # log_bin_index=master-bin.index

        # 删除超出这个变量保留期之前的全部日志被删除
        # expire_logs_days = 7

        
        需要复制的数据库名，如果复制多个数据库，重复设置这个选项即可
        binlog-do-db=
        
        不需要复制的数据库苦命，如果复制多个数据库，重复设置这个选项即可
        binlog-ignore-db=

        #即当主数据库又当从数据库时需开启log-slave-updates项
        #log-slave-updates

        # 设置方面提到过的三种Bin-log日志模式。
        # binlog_format = ROW

        # binary log 最大的大小
        # max_binlog_size = 50M

        # 当前的多少事务cache在内存中
        # binlog_cache_size = 1M

        # 当前有多少事务暂存在磁盘上的，如果这个值有数值的话，就应该要注意调优了。
        # binlog_cache_disk_use

        # 最大能有多少事务cache在内存中
        # max_binlog_cache_size
    </pre>

    <h3>slave从数据库my.conf配置</h3>
    <pre type="shell">
        [mysqld]
        #数据库标识，每个数据库标识必须唯一
        server-id=2

        #主数据库服务器的IP
        master-host=47.107.69.217

        #主数据库服务器的端口
        master-port=42206

        #主数据库服务器的登陆名 主服务器需要开启root@% 帐号
        master-user=root

        #主数据库服务器的登陆密码
        master-password=root@39doo.com

        # 设置为0，防止数据循环更新
        replicate-same-server-id=0

        #只镜像数据列表
        replicate-do-db=39doo
        #replicate-do-db=39doo2
        #replicate-do-db=39doo3

        #不同步的数据列表
        replicate-ignore-db=mysql
        #replicate-ignore-db=mysql2
        #replicate-ignore-db=mysql3

        #提供给主数据库用于反向连接的IP，因为主数据库有时无法正确判断从服务器的IP，所以这里最好填上从服务器自己的IP地址
        report-host=47.107.69.217
        report-port=42226
    </pre>
    <h3>slave从数据库 sql配置</h3>
    <pre type="shell">
        mysql> CHANGE MASTER TO 
            MASTER_HOST='192.168.8.10', 
            MASTER_PORT=3306,
            MASTER_USER='rep1',
            MASTER_PASSWORD='test123456',
            MASTER_LOG_FILE='binlog.000001',
            MASTER_LOG_POS=1304; #后面两个参数的值与主库保持一致


            MASTER_BIND = 'interface_name'
            //主服务器ip地址
            , MASTER_HOST = 'host_name' 

            //主服务器授权用户
            , MASTER_USER = 'user_name' 

            //主服务器授权密码
            , MASTER_PASSWORD = 'password' 

            //主服务器授权端口
            , MASTER_PORT = port_num  

            //在主服务器宕机或连接丢失的情况下，从服务器线程重新尝试连接主服务器之前睡眠的秒数
            , MASTER_CONNECT_RETRY = interval 

            // 重试次数
            , MASTER_RETRY_COUNT = count 

            // 延迟
            , MASTER_DELAY = interval 

            // 设置复制心跳的周期
            , MASTER_HEARTBEAT_PERIOD = interval 
            
            // 如果要告诉slave库从master二进制日志的哪个 　　地方开始复制，就要通过change master to 的master_log_file & master_log_pos 参数来指定
            , MASTER_LOG_FILE = 'master_log_name'
            , MASTER_LOG_POS = master_log_pos

            // 时使用MASTER_AUTO_POSITION = 1，slave连接master将使用基于GTID的复制协议
            , MASTER_AUTO_POSITION = {0|1} 
            , RELAY_LOG_FILE = 'relay_log_name'
            , RELAY_LOG_POS = relay_log_pos
            , MASTER_SSL = {0|1}
            , MASTER_SSL_CA = 'ca_file_name'
            , MASTER_SSL_CAPATH = 'ca_directory_name'
            , MASTER_SSL_CERT = 'cert_file_name'
            , MASTER_SSL_CRL = 'crl_file_name'
            , MASTER_SSL_CRLPATH = 'crl_directory_name'
            , MASTER_SSL_KEY = 'key_file_name'
            , MASTER_SSL_CIPHER = 'cipher_list'
            , MASTER_SSL_VERIFY_SERVER_CERT = {0|1}
            , IGNORE_SERVER_IDS = (server_id_list)            
    </pre>
    <br> <br>
    <p>show slave status \G;  查看同步结果</p>
    <div>
        <dl> <dt>1007</dt> <dd>数据库已存在，创建数据库失败</dd> </dl>
        <dl> <dt>1008</dt> <dd>数据库不存在，删除数据库失败</dd> </dl>
        <dl> <dt>1050</dt> <dd>数据表已存在，创建数据表失败</dd> </dl>
        <dl> <dt>1050</dt> <dd>数据表不存在，删除数据表失败</dd> </dl>
        <dl> <dt>1054</dt> <dd>字段不存在，或程序文件跟数据库有冲突</dd> </dl>
        <dl> <dt>1060</dt> <dd>字段重复，导致无法插入</dd> </dl>
        <dl> <dt>1061</dt> <dd>重复键名</dd> </dl>
        <dl> <dt>1068</dt> <dd>定义了多个主键</dd> </dl>
        <dl> <dt>1094</dt> <dd>位置线程ID</dd> </dl>
        <dl> <dt>1146</dt> <dd>因为主从同步只会同步并不会新建库</dd> </dl>
    </div>

</div>